<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>User Detail</title>
</head>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
    const vBASE_URL = "https://jsonplaceholder.typicode.com/users/";
    var gId ;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();

        $("#btn-update").on("click", function(){
            onBtnUpdateClick()
        })
        $("#btn-cancel").on("click", function(){
            onBtnCancelClick()
        })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        // b1: Thu thập dữ liệu
        var vUrl = new URL(window.location.href)
        gId = vUrl.searchParams.get("id")

        console.log(gId)

        //b2: Kiểm tra thông tin
        var isCheck = validateData()
        // b3: Gọi APi
        $.ajax({
            url:  vBASE_URL + "/" + gId,
            type: "GET",
            dataType: "json",
            success: function(paramResponse){
                console.log(paramResponse)
                showDataToForm(paramResponse)
            },
            error: function(paramError){
                console.log(paramError.status)
            }
        })
    }
    // hàm update User
    function onBtnUpdateClick(){
        var vReadData = readDataForm()
        var isCheckDataForm = validateDataForm(vReadData)
        if(isCheckDataForm){
            callApiUpdateUser(vReadData)
        }

    }

    // hàm nút cancel
    function onBtnCancelClick(){
        window.location.href = " Task%2035.10.html"
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    function  validateData(){
        if(gId === "" || gId === null){
            alert("Không có ID !!")
            return false
        }
        return true
    }
    function showDataToForm(paramOjb){
        $("#inp-id").html("ID: " + paramOjb.id );
        $("#inp-name").val(paramOjb.name )
        $("#inp-username").val(paramOjb.username )
        $("#inp-email").val(paramOjb.email )
        $("#inp-suite").val(paramOjb.address.suite )
        $("#inp-street").val(paramOjb.address.street )
        $("#inp-city").val(paramOjb.address.city )
        $("#inp-zipcode").val(paramOjb.address.zipcode )
        $("#inp-lat").val(paramOjb.address.geo.lat  )
        $("#inp-lng").val(paramOjb.address.geo.lng  )
        $("#inp-phone").val(paramOjb.phone )
        $("#inp-website").val(paramOjb.website )
        $("#inp-company-name").val(paramOjb.company.name )
        $("#inp-catch-phrase").val(paramOjb.company.catchPhrase )
        $("#inp-bs").val(paramOjb.company.bs )
    }

    // hàm đọc dữ liệu
    function readDataForm(){
        var vNewOjb = new Object()
       vNewOjb.name = $("#inp-name").val()
       vNewOjb.userName = $("#inp-username").val()
       vNewOjb.email = $("#inp-email").val()
       vNewOjb.suite = $("#inp-suite").val()
       vNewOjb.street = $("#inp-street").val()
       vNewOjb.city = $("#inp-city").val( )
       vNewOjb.zipCode = $("#inp-zipcode").val()
       vNewOjb.lat = $("#inp-lat").val()
       vNewOjb.lng = $("#inp-lng").val( )
       vNewOjb.phone = $("#inp-phone").val()
       vNewOjb.website = $("#inp-website").val()
       vNewOjb.companyName = $("#inp-company-name").val( )
       vNewOjb.catchPhrase = $("#inp-catch-phrase").val( )
       vNewOjb.bs = $("#inp-bs").val()

       return vNewOjb
    }

    function validateDataForm(paramOjb){
        if(paramOjb.name == ""){
            alert("Hãy nhập Name")
            return false
        }
        if(paramOjb.userName == ""){
            alert("Hãy nhập UserName")
            return false
        }
        if(paramOjb.email == ""){
            alert("Hãy nhập Email")
            return false
        }
        if(paramOjb.suite == ""){
            alert("Hãy nhập Suite")
            return false
        }
        if(paramOjb.street == ""){
            alert("Hãy nhập Street")
            return false
        }
        if(paramOjb.city == ""){
            alert("Hãy nhập City")
            return false
        }
        if(paramOjb.zipCode == ""){
            alert("Hãy nhập Zip Code")
            return false
        }
        if(paramOjb.lat == ""){
            alert("Hãy nhập lat")
            return false
        }
        if(paramOjb.lng == ""){
            alert("Hãy nhập lng")
            return false
        }
        if(paramOjb.phone == ""){
            alert("Hãy nhập Phone")
            return false
        }
        if(paramOjb.website == ""){
            alert("Hãy nhập Website")
            return false
        }
        if(paramOjb.companyName == ""){
            alert("Hãy nhập Company Name")
            return false
        }
        if(paramOjb.catchPhrase == ""){
            alert("Hãy nhập Catch Phrase")
            return false
        }
        if(paramOjb.bs == ""){
            alert("Hãy nhập bs")
            return false
        }
        return true
    }

    function callApiUpdateUser(paramOjb){
        $.ajax({
            url:  vBASE_URL + gId,
            type: "PUT",
            contentType:  "application/json;charset=UTF-8",
            data: JSON.stringify(paramOjb),
            success: function(paramResponse){
                alert("Update User thành công")
                console.log(paramResponse)
                
               
            },
            error: function(paramError){
                console.log(paramError.status)
            }

        })
    }
</script>

<body>
    <div class="container">
        <div class="jumbotron col-sm-10 mx-auto">
            <div class="row mb-4">
                <div class="col-sm-12 text-center">
                    <h2>Chi tiết User</h2>
                    <a id="inp-id"></a>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="">Name:</label>
                </div>
                <div class="col-sm-9">
                    <input class="form-control" type="text" id="inp-name">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="">UserName:</label>
                </div>
                <div class="col-sm-9">
                    <input class="form-control" type="text" id="inp-username">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="">Email:</label>
                </div>
                <div class="col-sm-9">
                    <input class="form-control" type="text" id="inp-email">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="">Address:</label>
                </div>
                <div class="col-sm-9">
                    <div class="row form-group">
                        <div class="col-sm-2">
                            <label for="">Suite:</label>
                        </div>
                        <div class="col-sm-10">
                            <input class="form-control" type="text" id="inp-suite">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-2">
                            <label for="">Street:</label>
                        </div>
                        <div class="col-sm-10">
                            <input class="form-control" type="text" id="inp-street">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-2">
                            <label for="">City:</label>
                        </div>
                        <div class="col-sm-10">
                            <input class="form-control" type="text" id="inp-city">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-2">
                            <label for="">Zipcode:</label>
                        </div>
                        <div class="col-sm-10">
                            <input class="form-control" type="text" id="inp-zipcode">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-2">
                            <label for="">Geo:</label>
                        </div>
                        <div class="col-sm-10">
                            <div class="row form-group">
                                <div class="col-sm-2">
                                    <label for="">lat:</label>
                                </div>
                                <div class="col-sm-10">
                                    <input class="form-control" type="text" id="inp-lat">
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-sm-2">
                                    <label for="">lng:</label>
                                </div>
                                <div class="col-sm-10">
                                    <input class="form-control" type="text" id="inp-lng">
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="">Phone:</label>
                </div>
                <div class="col-sm-9">
                    <input class="form-control" type="text" id="inp-phone">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="">Website:</label>
                </div>
                <div class="col-sm-9">
                    <input class="form-control" type="text" id="inp-website">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="">Company:</label>
                </div>
                <div class="col-sm-9">
                    <div class="row form-group">
                        <div class="col-sm-3">
                            <label for="">Name:</label>
                        </div>
                        <div class="col-sm-9">
                            <input class="form-control" type="text" id="inp-company-name">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-3">
                            <label for="">Catch Phrase:</label>
                        </div>
                        <div class="col-sm-9">
                            <input class="form-control" type="text" id="inp-catch-phrase">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-3">
                            <label for="">bs:</label>
                        </div>
                        <div class="col-sm-9">
                            <input class="form-control" type="text" id="inp-bs">
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-sm-12">
                    <button class="btn btn-primary  " id="btn-update">Update</button>
                    <button class="btn btn-danger  " id="btn-cancel">Cancel</button>
                    <button class="btn btn-success w-25 float-right" id="btn-back">Quay lại</button>
                </div>
            </div>
        </div>
    </div>
</body>

</html>